#include "g_local.h"

/*
==============
ResetLACfg

Resets LA config
==============
*/
void ResetLACfg (void)
{
	strcpy(config_server.gravity, "");
	strcpy(config_server.nextmap, "");
	strcpy(config_server.motd_file, "motd.txt");

	strcpy(config_server.adminName, "");
	strcpy(config_server.adminPass, "");
	config_server.admin = 0;

	config_server.allowShotgun = 1;
	config_server.allowSuperShotgun = 1;
	config_server.allowUzi = 1;
	config_server.allowChainGun = 1;
	config_server.allowGrenadeLauncher = 1;
	config_server.allowRocketLauncher = 1;
	config_server.allowHyperBlaster = 1;
	config_server.allowRailGun = 1;
	config_server.allowBFG = 1;

	config_server.motdtime = -1; //wait for jump to activate

	config_server.unlimitedAmmo = -1;
	config_server.weaponStay = -1;
	config_server.fraglimit = -1;
	config_server.timelimit = -1;

	config_server.dmturrets = 1;
	config_server.motd = 1;
	
	config_server.observersAllowed = -1;


}

/*
==============
ParseLACfg

Reads config.server and sets up level stuff.
==============
*/

void ParseLACfg (void)
{
	FILE *config;
	char line[80];
	char l_command[20];
	char l_var1[10];
	char l_var2[10];

	ResetLACfg();

	if (config = fopen("config.server", "r"))
	{
		// we successfully opened the file "config.server"
		while ( fgets(line, 80, config) )
		{
			// Read in each line for processing....
			if ((line[0] != ';') && (strlen(line) > 0))
			{
				sscanf (line, "%s %s %s", l_command, l_var1, l_var2);
				if (!stricmp("LevelSelect:", l_command ))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							strcpy (config_server.nextmap, l_var2);
					}
					
				}
				if (!stricmp(l_command, "DefaultLevel:"))
				{
					if ((strlen(l_var1) > 0) && (strlen(config_server.nextmap) > 0) )
					{
							strcpy (config_server.nextmap, l_var1);
					}
					
				}
				else if (!stricmp(l_command, "FragLimit:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							config_server.fraglimit = atoi(l_var2);
					}
					
				}
				else if (!stricmp(l_command, "TimeLimit:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							config_server.timelimit = atoi(l_var2);
					}
					
				}

				else if (!stricmp(l_command, "LevelGrav:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							strcpy (config_server.gravity, l_var2);
					}
					
				}
				else if (!stricmp(l_command, "DefaultGrav:"))
				{
					if ((strlen(l_var1) > 0) && (strlen(config_server.nextmap) > 0))
					{
							strcpy (config_server.gravity, l_var1);
					}
					
				}
				else if (!stricmp(l_command, "WeaponStay:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							if (!stricmp ("YES", l_var2))
							{
								config_server.weaponStay = 1;
							}
							else
							{
								config_server.weaponStay = 0;
							}
					}
					
				}
				else if (!stricmp(l_command, "WeaponStay:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							if (!stricmp ("YES", l_var2))
							{
								config_server.unlimitedAmmo = 1;
							}
							else
							{
								config_server.unlimitedAmmo = 0;
							}
					}
					
				}
				else if (!stricmp(l_command, "DMTurrets:"))
				{
					if ((strlen(l_var1) > 0))
					{
							if (!stricmp (l_var1, "YES"))
								config_server.dmturrets = 1;
							else
								config_server.dmturrets = 0;
					}
					
				}
				else if (!stricmp(l_command, "MOTD:"))
				{
					if ((strlen(l_var1) > 0))
					{
							if (!stricmp (l_var1, "NO"))
								config_server.motd = 0;
							else
								config_server.motd = 1;
					}
					
				}
				else if (!stricmp(l_command, "DefaultMotdTime:"))
				{
					if ((strlen(l_var1) > 0))
					{
							if (!stricmp (l_var1, "jump"))
								config_server.motdtime = -1;
							else
								config_server.motdtime = atoi(l_var1);
					}
					
				}
				else if (!stricmp(l_command, "MotdTime:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							if (!stricmp (l_var2, "jump"))
								config_server.motdtime = -1;
							else
								config_server.motdtime = atoi(l_var2);
					}
				}
				else if (!stricmp(l_command, "defaultmotdFile:"))
				{
					if ((strlen(l_var1) > 0))
					{
							strcpy (config_server.motd_file, l_var1);
					}
					
				}
				else if (!stricmp(l_command, "motdFile:"))
				{
					if ((!stricmp(l_var1, level.mapname)) && (strlen(l_var2) > 0))
					{
							strcpy (config_server.motd_file, l_var2);
					}
				}
			}
		}

		// close the file
    	fclose(config);
	}
	else
	{
		return;
	}

}
